############################################################
#                                                          #
#                 Load Observations                        #
#                                                          #
############################################################
#This script its called from UK to set the observations of Catalonia


#we have a doc where we have the reference of the stations that are in catalonia, if we want to change or amplify them we can change the coordinates of the box in set_stations script

pollutant      <-"no2"

# we prepare a matrix where we will save the observations:
obs                  <- matrix(NA,ncol=(nrow(local_stations@data)),nrow=0)
df_obs_all           <- data.frame(obs)
dates_all            <- data.frame(matrix(NA,ncol= 1,nrow=0))
#we transform from a matrix to a data frame, with the reference of the station as a name of the col
colnames(df_obs_all) <- c(local_stations@data$ref_obs)
colnames(dates_all)  <- c("date")

# finally we extract the observations of certain year_month
for (y_month in year_month) {
  #obs_path<-"/esarchive/scratch/mhajji/Meriem/RUN_UK_regional/LOOCV/observacions/"
  netcdf_obs    <- RNetCDF::open.nc(paste0(obs_path, "sconc", pollutant, "_", y_month, ".nc"))
  
  code_obs      <- RNetCDF::var.get.nc(netcdf_obs, 'station_reference')
  #station_name  <- RNetCDF::var.get.nc(netcdf_obs, "station_name")
  obs_all       <- RNetCDF::var.get.nc(netcdf_obs, "sconcno2")
  
  year            <- as.numeric(substr(y_month, 1, 4))
  month           <- as.numeric(substr(y_month, 5, 6))
  num_days        <- length(RNetCDF::var.get.nc(netcdf_obs, "time"))/24
  date_times_loc  <- data_frame_dates( c(year,month,01,00) , c(year,month,num_days,23) )
  dates_all       <- rbind(dates_all,date_times_loc)
  
  pos_local_stations  <- which(code_obs%in%local_stations@data$ref_obs)
  cat_obs             <- obs_all[,pos_local_stations]
  cat_ref             <- code_obs[pos_local_stations]
  #cat_names           <- station_name[pos_local_stations]
  
  obs_month               <- matrix(NA,ncol=length(cat_obs[1,]),nrow=length(cat_obs[,1])) 
  #cat_obs matriu de 72 col (estacions) i en aquest cas p.ex: 744 (31 dies de generx24h) i fem una obs month buida
  df_obs_month            <- data.frame(obs_month)
  colnames(df_obs_month)  <- paste0(cat_ref)
  df_obs_month[,]         <- cat_obs*1.88
  #df_obs_month            <- cbind(date = date_times_loc$date, df_obs_month)
  
  
  df_obs_all              <- rbind.fill(df_obs_all, df_obs_month) #in case there is no data on a certain date, it fills it with NA (rbind.fill)
  if ( ncol(df_obs_all)!=ncol(df_obs_month) ) {
    print(paste0("ERROR: number of monitoring stations is not constant when loading observations. ","Filled with NA in: ",y_month))
  }
}

df_obs_all <- cbind(dates_all,df_obs_all)

saveRDS(object=df_obs_all, file=paste0(save_result,"/df_obs.rds"))

#time_subset permits us to select the observations at the same dates as the model (remember: at first we extract observations monthly)
df_obs_sub <- time_subset(data = df_obs_all, time_var_name = "date",
                          date_time_begin = date_time_begin,
                          date_time_end = date_time_end)