
#Mesurem el temps que triga en executarse l'anàlisi d'una hora
start_time <- Sys.time()

#-------------------------------------------------------------------------------
#                                 UNIVERSAL KRIGING
#-------------------------------------------------------------------------------
library(urbanR)
library(RNetCDF) 
library(sp)
library(sf)
#library(mapview) 
library(ncdf4) #Es per el model
library(rgeos) #Es una llibreria per fer lo del buffer
library(ggplot2)
library(dplyr)
library(broom)
library(ggpubr)
library(raster)
library(rgdal)
library(tmap)
library(gstat)
library(sp)
#-------------------------------------------------------------------------------

# ## LOAD config_file
# args = commandArgs(TRUE)
# if (length(args) > 0) {
#   configFile_path <- args[1]
# } else {
#   cat("\n***WARNING: no ConfigFile was provided. Using default ConfigFile.\n")
# }


############################################################
#                                                          #
#              Set temporal context                        #
#                                                          #
############################################################

# config           <- yaml::yaml.load_file(configFile_path)
# sim_folder_path  <- config$sim_folder_path
# obs_path         <- config$obs_path
# date_time_begin  <- config$date_time_begin
# date_time_end    <- config$date_time_end
# pollutant       <- config$pollutant
# #obs_path       <- "/gpfs/projects/bsc32/AC_cache/obs/ghost/EEA_AQ_eReporting/1.4/hourly/sconcno2/sconcno2_202101.nc"
# 
# #crec que year_month es una columna amb tot de files de dates entonces, year_month[1,]
# 
#pollutant <- "no2"
# 
# date_times    <- data_frame_dates(date_time_begin = date_time_begin,
#                                date_time_end = date_time_end)
# dates         <- unique(paste0(as.character(strftime(date_times[, 1], format="%Y", tz = "UTC")),
#                        as.character(strftime(date_times[, 1], format="%m", tz = "UTC")),
#                        as.character(strftime(date_times[, 1], format="%d", tz = "UTC"))))
# year_month    <- unique(paste0(as.character(strftime(date_times[, 1], format="%Y", tz = "UTC")),
#                             as.character(strftime(date_times[, 1], format="%m", tz = "UTC"))))
# 
# # !!! OJO !!! Aqui t'agafa les estacions del mes de l'any de date_time_begin, potser no hi son totes!!
# # Lo ideal  seria que et mires cada mes des de date_time_begin fins a date_time_end i agafes el vector més llarg
obs_path_stations      <- paste0(obs_path, "sconc",pollutant,"_",year_month[1],".nc")



#Dades de les estacions:
netcdf_obs        <- RNetCDF::open.nc(obs_path_stations)

#Arreglem les dades de les observacions
lat_obs      <- RNetCDF::var.get.nc(netcdf_obs, 'latitude') 
lon_obs      <- RNetCDF::var.get.nc(netcdf_obs, 'longitude')
ref_obs      <- RNetCDF::var.get.nc(netcdf_obs, 'station_reference')
station_name <- RNetCDF::var.get.nc(netcdf_obs, "station_name")
obs_all      <- RNetCDF::var.get.nc(netcdf_obs, paste0("sconc",pollutant))
df_obs       <- data.frame(pollutant=obs_all[1,], lat_obs=lat_obs, lon_obs=lon_obs, ref_obs=ref_obs,station_name=station_name)
coordinates(df_obs)=~lon_obs+lat_obs



#Coordenades
crs_model                 <- "+proj=longlat +datum=WGS84 +ellps=WGS84 +towgs84=0,0,0" 
sp::proj4string(df_obs)   <- crs_model

#Assignar el limit 'box' en el mapa
my_box      <- rgeos::bbox2SP(43.02355,40.24870,3.497162,-0.001190186, proj4string = CRS(crs_model)) # lat màx, lat min, lon max, lon min

#Extraiem les coordenades de les observacions que es troben dintre de l'àrea limitada 'my box'
conjunt     <- raster::intersect(df_obs,my_box) #Fa una llista de les obs de NO2 que estiguin dindre de l'àrea del box

local_stations      <- conjunt

saveRDS(object=conjunt, file=paste0(save_result,"local_stations_",pollutant,".rds"))
#saveRDS save data into R Data Format


end_time <- Sys.time()
temps_total <- end_time-start_time
print(paste0(temps_total," ","local stations")



